using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Resources;
using System.Reflection;
using System.Threading;
using System.Globalization;

namespace RTGA
{
	/// <summary>
	/// Class implementing the banner (upper) part of the frameset
	/// Mihai Virtosu, virtosumihai@yahoo.com
	/// </summary>
	public class banner : System.Web.UI.Page
	{
		#region Protected Members
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Label Label1;
		#endregion


		#region Private Members
		private string strTitle;
		#endregion

		#region Page Load

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			
			//Localizable settings
			if (!IsPostBack)
			{
				// Get the user's perferred language.
				string sLang = Request.UserLanguages[0];
				// Set the thread's culture for formatting, comparisons, etc.
				Thread.CurrentThread.CurrentCulture = 
					CultureInfo.CreateSpecificCulture(sLang);
				// Set the thread's UICulture to load resources 
				// from satellite assembly.
				Thread.CurrentThread.CurrentUICulture = new CultureInfo(sLang);
			}

			GetLocaleStrings();
			
			Label1.Text = strTitle;
		}

		#endregion

		#region Private Methods

		/// <summary>
		/// Method that will get the localizable strings from the resource files
		/// </summary>
		void GetLocaleStrings()
		{
			ResourceManager resMan = new ResourceManager("RTGA.banner",
				Assembly.GetExecutingAssembly());

			strTitle = resMan.GetString("Title");
		}
		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
